A969 | Train Tracking 2--Platinum
来源USACO
时间限制1s
内存限制128MB
通过 / 提交0/0
题目描述
Every day the express train goes past the farm. It has $N$ carriages ($1 \leq
N \leq 10^5$), each with a positive integer label between $1$ and $10^9$;
different carriages may have the same label.
Usually, Bessie watches the train go by, tracking the carriage labels. But
today is too foggy, and Bessie can't see any of the labels! Luckily, she has
acquired the sliding window minimums of the sequence of carriage labels, from
a reputable source in the city. In particular, she has a positive integer $K$,
and $N-K+1$ positive integers $c_1,\dots,c_{N+1-K}$, where $c_i$ is the
minimum label among carriages $i, i+1, \dots, i+K-1$.
Help Bessie figure out the number of ways to assign a label to each carriage,
consistent with the sliding window minimums. Since this number may be very
large, Bessie will be satisfied if you find its remainder modulo $10^9 + 7$.
Bessie's information is completely reliable; that is, it is guaranteed that
there is at least one consistent way to assign labels.
N \leq 10^5$), each with a positive integer label between $1$ and $10^9$;
different carriages may have the same label.
Usually, Bessie watches the train go by, tracking the carriage labels. But
today is too foggy, and Bessie can't see any of the labels! Luckily, she has
acquired the sliding window minimums of the sequence of carriage labels, from
a reputable source in the city. In particular, she has a positive integer $K$,
and $N-K+1$ positive integers $c_1,\dots,c_{N+1-K}$, where $c_i$ is the
minimum label among carriages $i, i+1, \dots, i+K-1$.
Help Bessie figure out the number of ways to assign a label to each carriage,
consistent with the sliding window minimums. Since this number may be very
large, Bessie will be satisfied if you find its remainder modulo $10^9 + 7$.
Bessie's information is completely reliable; that is, it is guaranteed that
there is at least one consistent way to assign labels.
输入格式
The first line consists of two space-separated integers, $N$ and $K$. The
subsequent lines contain the sliding window minimums $c_1,\dots,c_{N+1-K}$,
one per line.
subsequent lines contain the sliding window minimums $c_1,\dots,c_{N+1-K}$,
one per line.
输出格式
A single integer: the number of ways, modulo $10^9 + 7$, to assign a positive
integer not exceeding $10^9$ to each carriage, such that the minimum label
among carriages $i, i+1, \dots, i+K-1$ is $c_i$ for each $1 \leq i \leq
N-K+1$.
integer not exceeding $10^9$ to each carriage, such that the minimum label
among carriages $i, i+1, \dots, i+K-1$ is $c_i$ for each $1 \leq i \leq
N-K+1$.
输入输出样例
输入 #1
4 2 999999998 999999999 999999998
输出 #1
3
暂无题解
C++ 编辑器
输入
输出
可保存默认模板;新题优先使用已保存模板。
当前快捷键仅展示,暂不支持修改。
- 撤销
Ctrl / ⌘ + Z - 重做
Ctrl / ⌘ + Y - 查找
Ctrl / ⌘ + F - 全选
Ctrl / ⌘ + A - 复制
Ctrl / ⌘ + C - 剪切
Ctrl / ⌘ + X - 粘贴
Ctrl / ⌘ + V - 自动排版
工具栏排版按钮 - 草稿保存
编辑时自动保存到本机
历史
提交记录
状态说明时间源码
AI
作答助手
你好,我是作答助手。可以问思路、复杂度、样例含义或代码报错原因;不会直接给出完整 AC 代码。
确定要清空代码吗?
提交通过
评测结果:Accepted